{% extends "layout.html" %}

{% block head %}
{% endblock %}

{% block title %}
    <a href="/curriculum">Learning</a>
    <a href="/curriculum#{{extnode.period}}">{{extnode.period}}</a>
    {% if extnode.module and extnode.module.name %}
        <a href="/curriculum#{{extnode.period}}">{{extnode.module.short or extnode.module.name}}</a>
    {% endif %}
    <a href="/curriculum/{{extnode.id}}">{{extnode.name}}</a>
    {% if student and student.id != current_user.id %}
    <a href="/people/{{student.id}}">{{ student.first_name }}</a>
    {% endif %}
{% endblock %}

{% block body %}

<table class="mar3" style="width: 100%;">
    <tr><th>Description</th><td>{{extnode.description}}</td></tr>
    <tr><th>Type</th><td>{{ {
        "hand-in": "Hand-in assignment with oral explanation",
        "assessment": "Hand-in assignment with assessment",
        "portfolio": "Portfolio with public defense",
        "project": "Project with assessment",
        "internship": "Internship",
        "overhead": "Preparations",
        "workshop": "Mandatory workshop",
    }[extnode.type] or extnode.type }}.</td></tr>
    <tr><th>Duration</th><td>{{ 'About' if extnode.allow_longer or not extnode.ects else 'At most'}} {{extnode.days}} {{'working days' if extnode.days > 1 else 'working day'}}.</td></tr>
    <tr><th>Progress points</th><td>{{extnode.get('avg_days', extnode.days*extnode.avg_attempts)}}</td></tr>
    {% if extnode.ects %}
        <tr><th>Credits</th><td>{{extnode.ects}}</td></tr>
        <tr><th>Test matrix</th><td>
            <table class="map-table">
                <thead><tr>
                    <th>
                        {{"Final qualification" if extnode.id=="graduation" else "Learning goal"}}
                        <div class='tag endterm_info{{" hidden" if extnode.id=="graduation" else ""}}' 
                            data-tooltip="The number represents the end qualification associated to the learning goal (also see curriculum page).">
                            ?
                        </div>
                    </th>
                    <th>Know</th>
                    <th>Comprehend</th>
                    <th>Apply</th>
                    <th>Analyze</th>
                    <th>Evaluate</th>
                    <th>Create</th>
                    <th>Σ</th>
                </tr></thead>
                <tbody>
                {% for goal in extnode.goals.values() %}
                    <tr>
                        <td>
                            {{goal.title}}
                            
                            {%for outcome_id in goal.outcome_ids%}
                                {%set outcome = outcomes_by_id[outcome_id]%}
                                <div class="tag endterm{{outcome.endterm_number}}" data-tooltip="{{endterms[outcome.endterm_number-1].title.rstrip('.')}}: {{outcome.title}}">
                                    {{outcome.endterm_number}}
                                </div>
                            {%endfor%}
                        </td>
                        {% for bloom in ['know', 'comprehend', 'apply', 'analyze', 'evaluate', 'create'] %}
                            {% if bloom in goal %}
                                {% if goal.weight %}
                                    <td>{{(goal.fraction * (goal[bloom] or 0) / goal.weight * 100)|round|int}}</td>
                                {% else %}    
                                    <td>must</td>
                                {% endif %}
                            {% else %}
                                <td></td>
                            {% endif %}
                        {% endfor %}
                        <th>
                            {{'%0.1f'| format(goal.fraction * 100)|float}}
                        </th>
                    </tr>
                {% endfor %}
            </tbody></table>
        </td></tr>
 
    {% elif extnode.goals %}
        <tr><th>Learning goals</th><td class="content">
            <ul>
                {% for goal in extnode.goals.values() %}
                    <li>{{goal.title}} <span class="tag no-float">{{(goal.fraction * 100)|round|int}}%</span></li>
                {% endfor %}
            </ul>
        </td></tr>
    {% endif %}
    {% if extnode.pair %}
        <tr><th>Pair programming</th><td class="content rows2">
            {% if extnode.pair is string %}
                {{extnode.pair | markdown | safe}}
            {% else %}
            You are allowed (but not required) to work together with a fellow student, practicing <a href="https://www.youtube.com/watch?v=ET3Q6zNK3Io">pair programming</a>.
            <ol>
                <li>Find a student who's also ready to do this assignment.</li>
                <li>Both of you start the assignment and fill in <code>PAIR_PROGRAMMING.md</code>.</li>
                <li>Do the assignment working together on one computer, alternating roles.</li>
                <li>Both of you submit at the same time, with only one uploading the actual code.</li>
                <li>We'll review and grade you together.</li>
            </ol>
            {% endif %}
            <div>
                {% for pair_option in pair_options %}
                <a href="/people/{{pair_option.short_name}}" class="pair_option">
                    <img class="avatar is-prefix" src="{{pair_option.avatar}}" alt="Avatar">
                    {{pair_option.full_name}}
                </a>
                {% endfor %}
            </div>
        </td></tr>
    {% endif %}

    {% if extnode.about %}
    <tr><th>About this lesson</th><td class="content rows1">{{extnode.about | markdown | safe}}</td></tr>
    {% endif %}
    
    {% if status %}
        <tr><th>Status</th><td class="content">
        <ul>
            {% for error in status.errors %}
                <li>{{error|inline_markdown|safe}} <span class="tag is-important no-float">Blocking</span></li>
            {% endfor %}
            {% for approval in status.approvals %}
                <li>{{approval|inline_markdown|safe}} <span class="tag is-info no-float">Approval required</span></li>
            {% endfor %}
            {% for warning in status.warnings %}
                <li>{{warning|inline_markdown|safe}} <span class="tag is-warning no-float">Warning</span></li>
            {% endfor %}
        </ul>

        {% if status.action %}
            <div class="buttons">
                <form method="POST">
                    <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
                    <input class="button is-primary" type="submit" name="{{status.action}}" value="{{status.action_text or status.action}}">
                </form>
            </div>
        {% endif %}
        </tr>
    {% endif %}


    {% if current_user.is_authenticated and current_user.is_teacher %}
        {% if extnode.errors %}
            <tr><th>Teacher errors</th><td class="content"><ul>
                {% for error in extnode.errors %}
                    <li class="has-text-danger">{{error|markdown|safe}}</li>
                {% endfor %}
            </ul></td></tr>
        {% endif %}
        {% if extnode.warnings %}
            <tr><th>Teacher warnings</th><td class="content"><ul>
                {% for warning in extnode.warnings %}
                    <li class="has-text-danger">{{warning|markdown|safe}}</li>
                {% endfor %}
            </ul></td></tr>
        {% endif %}
        {% if extnode.plans %}
            <tr><th>Teacher plans</th><td class="content">
                {{extnode.plans|markdown|safe}}
            </td></tr>
        {% endif %}
    {% endif %}
</table>

{% if assignments|length > 1 %}
<div class="tab-selectors mar3">
{% for name, assignment in assignments.items() %}
    <button class="link-button">
        {{ name }}
    </button>
{% endfor %}
</div>
{% endif %}

<div class="tab-blocks mar3">
    {% for name, assignment in assignments.items() %}
        <div class="rows3">
            {% if assignment.notifications or assignment.others %}
            <div class="notification is-info">
                {% for notification in assignment.notifications %}
                    <div class="rows2">{{notification|safe}}</div>
                {% endfor %}

                {% if assignment.others %}
                    <p>
                        {{assignment.others_message}}
                        {% for user,link in assignment.others %}
                        <a class="presence-avatar {{user.presence_class}}" href="{{link}}">
                            <img class="avatar is-prefix" src="{{user.avatar}}" alt="Avatar">
                            {{user.first_name}}
                        </a>
                        {% endfor %}
                    </p>
                {% endif %}
            </div>
            {% endif %}

            {% if assignment.require_recording %}
            <div class="notification is-warning rows2">
                <script src="/static/record.js"></script>
                <script>recordInit(document.currentScript.parentNode, {{csrf_token() | json | safe}}, {{assignment.require_recording | json | safe}})</script>
            </div>
            {% endif %}
    
            {% set show_grader_selector = (grade_teachers and assignment.attempt and assignment.attempt.status in ['needs_grading', 'needs_consent']) %}
            {% if assignment.buttons or show_grader_selector %}
            <div class="buttons">
                {% for button in assignment.buttons %}
                {{button|safe}}
                {% endfor %}

                {% if show_grader_selector %}
                <div style="display: flex; gap: var(--mar2); align-items: center;">
                    <select name="grade_teacher" hx-put="/inbox/{{assignment.attempt_id}}/grade_teacher" hx-trigger="change" hx-swap="none">
                        <option value="">-</option>
                        {% for teacher in grade_teachers %}
                            <option value="{{ teacher.id }}" {{ 'selected' if teacher.id == assignment.attempt.grade_teacher_id else '' }}>
                                {{ teacher.short_name }}
                            </option>
                        {% endfor %}
                    </select>
                </div>
                {% endif %}
            </div>
            {% endif %}

            <section class="assignment">
                {{ assignment.html|safe }}

                {% if assignment.submit_form %}
                <h1>Submit attempt</h1>
                
                {% for warning in assignment.submit_warnings %}
                <div class="mt-4 notification is-warning">{{warning}}</div>
                {% endfor %}
                
                {% from "form-macro.html" import form_macro %}
                {{ form_macro(assignment.submit_form) }}
                <script src="/static/feedback.js"></script>
                {% endif %}
                
            </section>

            {% if assignment.files %}
            <section>
                <h1>Files</h1>
                <ul>
                    {% for file in assignment.files %}
                    <li><a href="{{file_base}}{{file}}" download>{{file}}</a></li>
                    {% endfor %}
                </ul>
            </section>
            {% endif %}
        </div>
    {% endfor %}
</div>
<script>dispatchEvent(new Event('load')); /* for htmx swaps */</script>
<script src="/static/copy-code.js"></script>
{% endblock %}
